var KingModel = function() {
  var kingVersion;
  var kingUnits;
  var currentUnit;
  var currentTrick;
  var nextTrickPlayerPos;
  var playedUnits = {};
  var myChosen;
  var trumpPlayed = false;
  var almostTrumpPlayed = false;
  var trumpAkqPlayed = false;
  this.tricksEnded = {}
  
  this.getCurrentUnit = function() {
    return currentUnit;
  };
  this.getCurrentUnitStr = function() {
    if (currentUnit) {return currentUnit.unit.replace(/_/g,' ');}
    else {return '';}    
  };
  this.isTrumpGame = function() {
    if (currentUnit) {return currentUnit.isTrump;}
    else {return undefined;}
  }
  this.setCurrentUnit = function(kingUnit) {
    currentUnit = kingUnit;
  };
  this.getCurrentTrick = function() {
    return currentTrick;
  };
  this.setCurrentTrick = function(trick) {
    currentTrick = trick;
  };
  this.setNextTrickPlayerPos = function(pos) {
    nextTrickPlayerPos = pos;
  };
  this.getNextTrickPlayerPos = function() {
      return nextTrickPlayerPos;
  };
  this.getPlayedUnits = function() {
    return playedUnits;
  };
  this.clearPlayedUnits = function() {
    playedUnits = {};
  };
  this.addPlayedUnit = function(kingUnit) {
    var cnt = playedUnits[kingUnit];
    if (!cnt) {cnt = 1;}
    else {++cnt;}
    playedUnits[kingUnit] = cnt;
  };
  this.getTotalNumOfPlayedUnits = function() {
    var cnt = 0;
    for (var key in playedUnits) {
      cnt += playedUnits[key];
    }
    return cnt;
  };
  this.getNumOfPlayedUnit = function(kingUnit) {
    var cnt = playedUnits[kingUnit];
    return cnt?cnt:0;
  };
  this.getTrumpPlayed = function() {
    return trumpPlayed;
  };
  this.setTrumpPlayed = function(tp) {
    trumpPlayed = tp;
  };
  this.getAlmostTrumpPlayed = function() {
    return almostTrumpPlayed;
  };
  this.setAlmostTrumpPlayed = function(atp) {
    almostTrumpPlayed = atp;
  };
  this.getTrumpAkqPlayed = function() {
    return trumpAkqPlayed;
  };
  this.setTrumpAkqPlayed = function(takqp) {
    trumpAkqPlayed = takqp;
  };
};
KingModel.prototype = new CardModel();
(function() {
  var init = KingModel.prototype.init;
  KingModel.prototype.init = function() {
    init.call(this);
    this.clearPlayedUnits();

    for (var i=0; i<20; ++i) {
      this.tricksEnded[i]=[];
      for (var j=0; j<this.NUM_CARD_IN_DEAL_HAND; ++j) {
        this.tricksEnded[i].push($.Deferred());
      }
    }

    this.init_unit();
  };
})();
(function() {
  var startGame = KingModel.prototype.startGame;
  KingModel.prototype.startGame = function() {
    startGame.call(this);
    this.init_unit();
  }
})();
KingModel.prototype.init_unit = function() {
  this.setNextTrickPlayerPos(undefined);
  this.setCurrentUnit(undefined);
  this.setCurrentTrick(0);
  this.setTrumpPlayed(false);
  this.setAlmostTrumpPlayed(false);
  this.setTrumpAkqPlayed(false);
};
KingModel.prototype.wPoint = function(wPoint) {
};
KingModel.prototype.endTrick = function(currentDealNum, taker) {
  var trick=this.getCurrentTrick();
  this.tricksEnded[currentDealNum][trick].resolve(taker);
  this.setCurrentTrick(++trick);
};
KingModel.prototype.endUnit = function(totalPlayedUnit) {
  this.setCurrentDealNum(totalPlayedUnit);
};
KingModel.prototype.clearTableOneTrick = function() {
  var table = this.getTable();
  this.setTable(table.splice(0, this.getTotalNumOfPlayers()));
};

var KingUnits={};
var KingUnit = function(id, name, cat, trump, trump_point, almost_trump, suits_w_pnt, ranks_w_pnt, cards_w_pnt, tricks_w_pnt) {
  this.id = id;
  this.name = name;
  this.cat = cat;
  if (cat == 'TRUMP') {
    this.trump_point = trump_point;
    return;
  }
  this.almost_trump = almost_trump;
  this.suits_w_pnt = suits_w_pnt;
  this.ranks_w_pnt = ranks_w_pnt;
  this.cards_w_pnt = cards_w_pnt;
  this.tricks_w_pnt = tricks_w_pnt;
};



var KingView = function() {
  this.trickEndTO = 2000;
  this.unitEndTO = 5000;
  this.wBtwNonTrumpCards = 25;
  this.NonTrumpCardW = this.cardW;
  this.NonTrumpCardH = 60;
  this.cardwPointWsm = 28;
  this.cardwPointHsm = 22;
  this.chosenUnitH = 160;
  //this.chosenMarkW = 42;
  //this.chosenMarkH = 23;
  this.dialogs[CardView.DIALOGS.SELECT_UNIT.name]=$('#dialog-selectUnit');
  this.dialogs[CardView.DIALOGS.WAIT_SELECT.name]=$('#dialog-waitingUnitSelect');
  this.maxDealNum = 20;
};
KingView.prototype = new CardView();
CardView.DIALOGS['SELECT_UNIT'] = {name:'SELECT_UNIT'};
CardView.DIALOGS['WAIT_SELECT'] = {name:'WAIT_SELECT'};
CardView.TIMEOUTIDS = {WAIT_SELECT:'WAIT_SELECT'};
(function() {
  var startGame = KingView.prototype.startGame;
  KingView.prototype.startGame = function() {
    startGame.call(this);
    this.init_unit();
  }
})();
(function() {
	var customize = KingView.prototype.customize;
	KingView.prototype.customize = function(size) {
		customize.call(this, size);
	  this.numOfTakenTextSize = {sm:20};
	  this.totalPointTextSize = {sm:20};
		var numOfTakenTricksW, numOfTakenTricksN, numOfTakenTricksE, numOfTakenTricksS;
		if (size == 'lg') {
		  numOfTakenTricksW = {x:0, y:100};
      numOfTakenTricksE = {x:0, y:100};
      numOfTakenTricksN = {x:110, y:-30};
      numOfTakenTricksS = {x:70, y:40};
		}
		else {
		  numOfTakenTricksW = {x: Math.floor(this.EASTs.sm.username.plate.x + 18), y: Math.floor(this.WESTs.sm.username.plate.y + 4)};
		  numOfTakenTricksE = {x: Math.floor(this.EASTs.sm.username.plate.x + 100), y: Math.floor(this.EASTs.sm.username.plate.y + 4)};
		  numOfTakenTricksN = {x: Math.floor(this.NORTHs.sm.username.plate.x + 18), y: Math.floor(this.NORTHs.sm.username.plate.y + 27)};
		  numOfTakenTricksS = {x: Math.floor(this.SOUTHs.sm.username.plate.x + 18), y: Math.floor(this.SOUTHs.sm.username.plate.y + 4)};
		}
		
		this.playerPosCoords.SOUTH.king = {nonTrumpCards:{x:Math.floor(this.userGroupS_W/2),y:30}, numOfTakenTricks:numOfTakenTricksS, totalPoint: {x:72, y:4}};
		this.playerPosCoords.WEST.king = {nonTrumpCards:{x:0,y:0}, numOfTakenTricks:numOfTakenTricksW, totalPoint: {x:72, y:4}};
		this.playerPosCoords.NORTH.king = {nonTrumpCards:{x:0,y:0}, numOfTakenTricks:numOfTakenTricksN, totalPoint: {x:72, y:27}};
		this.playerPosCoords.EAST.king = {nonTrumpCards:{x:0,y:0}, numOfTakenTricks:numOfTakenTricksE, totalPoint: {x:22, y:4}};
	}
})();
(function() {
  var init = KingView.prototype.init;
  KingView.prototype.init = function() {
    init.call(this);
    var that = this;

    that.$chosenUnitFigDiv = that.$domComponents.find('.div-chosenUnitFig');
    that.$domContainer.append(that.$chosenUnitFigDiv);
    var points = {};
    for (var key in CardView.PLAYER_POSITIONS) {
      points[CardView.PLAYER_POSITIONS[key].val] = 0;
    }
    that.addPoints('', points);
    
    if (that.smallScreen) {
      $('.kingInfo').css('height', ($('#container').position().top - $('.navbar').outerHeight(true))-4);

      that.upperStageW = Math.floor(that.mainW*0.8)-4;
      that.upperStageH = $('.kingInfo').height();
      
      that.display.renderer_upper = new PIXI.autoDetectRenderer(that.upperStageW, that.upperStageH, {transparent: true});
      document.getElementById('container2').appendChild(that.display.renderer_upper.view);
      that.display.upper_stage = new PIXI.Container();
    }
    else {
      $('.kingInfo').css('height', screen.availHeight - 90 - (that.mainH+$('.navbar').outerHeight(true)));
    }
  }
})();
var KingPlayerView = function(pos) {
	PlayerView.call(this, pos);
	
	this.usernameGroup.numOfTakenTricks = new PIXI.Text('0', {font:'bold '+CardGame.view.numOfTakenTextSize.sm+'px '+'Calibri', fill:'red'});
	this.usernameGroup.totalPoint = new PIXI.Text('0', {font:'bold '+CardGame.view.totalPointTextSize.sm+'px '+'Calibri', fill:CardGame.view.textGreen});
	this.usernameGroup.addChild(this.usernameGroup.numOfTakenTricks);
	this.usernameGroup.addChild(this.usernameGroup.totalPoint);
	if (!CardGame.view.smallScreen) {
		this.nonTrumpCardsView = new PIXI.Container();
		this.nonTrumpCardsView.width = 250;
		this.nonTrumpCardsView.width = 60;
		this.addChild(this.nonTrumpCardsView);
	}
	
}

KingPlayerView.prototype = Object.create(PlayerView.prototype);
KingPlayerView.prototype.constructor = KingPlayerView;
(function() {
  var init = PlayerView.prototype.init;
  KingPlayerView.prototype.init = function(isPartial) {
    init.call(this, isPartial);
  };
})();
(function() {
	var setCoords = PlayerView.prototype.setCoords;
	KingPlayerView.prototype.setCoords = function(coords) {
		setCoords.call(this, coords);
		this.usernameGroup.numOfTakenTricks.position.set(coords.king.numOfTakenTricks.x, coords.king.numOfTakenTricks.y);
		this.usernameGroup.totalPoint.position.set(coords.king.totalPoint.x, coords.king.totalPoint.y);

		if (!CardGame.view.smallScreen) {
			this.nonTrumpCardsView.position.set(coords.king.nonTrumpCards.x, coords.king.nonTrumpCards.y);
		}
	}
})();

(function() {
  var movePlayer = KingView.prototype.movePlayer;
  KingView.prototype.movePlayer = function(playerView, newPos, callback) {
    movePlayer.call(this, playerView, newPos, callback);
    var coords = this.playerPosCoords[newPos];
    var nonTrumpCardsView = playerView.nonTrumpCardsView;
    if (nonTrumpCardsView) {nonTrumpCardsView.position.set(coords.king.nonTrumpCards.x, coords.king.numOfTakenTricks.y);}
    var numOfTricksText = playerView.usernameGroup.numOfTakenTricks;
    numOfTricksText.position.set(coords.king.numOfTakenTricks.x, coords.king.numOfTakenTricks.y);
    var totalPointText = playerView.usernameGroup.totalPoint;
    totalPointText.position.set(coords.king.totalPoint.x, coords.king.totalPoint.y);
  };
})();
(function() {
  var addPlayer = KingView.prototype.addPlayer;
  KingView.prototype.addPlayer = function(player, isMe) {
    addPlayer.call(this, player, isMe);
    $('#scoreTable').find('#plScore-'+player.seat+' span').text(player.username);
  };
})();
(function() {
    var removePlayer = KingView.prototype.removePlayer;
    KingView.prototype.removePlayer = function(player) {
      removePlayer.call(this, player);
      $('#scoreTable').find('#plScore-'+player.seat+' span').text('Player '+(player.seat+1));
    };
})();
(function() {
    var playCardOnTable = KingView.prototype.playCardOnTable;
    KingView.prototype.playCardOnTable = function(card, player, dealNum, trick, callback) {
      var that=this;

      playCardOnTable.call(that, card, player, dealNum, trick, function() {
        that.unblinkUsername(player);
        if (callback) {callback();}
      });
    };
})();

(function() {
  var initToResume = KingView.prototype.initToResume;
  KingView.prototype.initToResume = function(props) {
    initToResume.call(this, props);
    this.tableState.clearedCnt = props.currentTrick;
    var seats = props.seats;
    var unitPoints = [];
    for (var i=0; i<seats.length; ++i) {
      if (props.takenValCardsInUnit) {this.addTakenCardsWPoint(seats[i].position, props.takenValCardsInUnit);}
      if (seats[i].numOfTakenValTricksInUnit > 0) {this.addTakenTrick(seats[i].position, seats[i].numOfTakenValTricksInUnit);}
      
      for (var key in seats[i].unitPoints) {
        for (var j=0; j<seats[i].unitPoints[key].length; ++j) {
          var points = {};
          points[seats[i].position] = seats[i].unitPoints[key][j]
          unitPoints.push({unit:key, point:points});
        }
      }
    }

    if (props.currentUnit) {this.showChosenUnit(props.currentUnit);}

    this.showNextTrickPlayer(props.nextTrickPlayingSeat);
    for (var i=0; i<unitPoints.length; ++i) {
      this.addPoints(unitPoints[i].unit, unitPoints[i].point);
      if (this.smallScreen) {
        this.addPointToTotalPointViews(unitPoints[i].point);
      }
    }
  }
})();

KingView.prototype.addTakenCardsWPoint = function(seat, cards) {
  var playerView = this.display.playerViews[seat];
  var coords = this.playerPosCoords[playerView.pos];
  
  var nonTrumpCardsView = playerView.nonTrumpCardsView;
  if (!this.smallScreen) {
	  
	  if (playerView.pos != 'SOUTH') {
	    for (var i=0;i<cards.length;++i) {
	    	var len = nonTrumpCardsView.children.length;
	    	var x,y;
        
	    	x = (len%7)*this.wBtwNonTrumpCards;
	    	y = parseInt(len/7)*(this.NonTrumpCardH/2);
        
	    	var cardView = this.display.cards_cp[Card.getId(cards[i].suit, cards[i].rank)];
	    	cardView.position.set(x, y);
	    	nonTrumpCardsView.addChild(cardView);
	    }
	  }
	  else {
	    for (var i=0;i<cards.length;++i) {
	    	var len = nonTrumpCardsView.children.length;
	    	var x = len==0?0:nonTrumpCardsView.children[len-1].x+this.wBtwNonTrumpCards;
	    	var y = 0;
	    	var cardView = this.display.cards_cp[Card.getId(cards[i].suit, cards[i].rank)];
	    	cardView.position.set(x, y);
	    	nonTrumpCardsView.addChild(cardView);
	    }
      
	    var useW = this.NonTrumpCardW + (nonTrumpCardsView.children.length-1)*this.wBtwNonTrumpCards;
	    nonTrumpCardsView.x = nonTrumpCardsView.x-Math.floor((cards.length*this.wBtwNonTrumpCards)/2);
	  }
  }
  else {
    for (var i=0; i<cards.length; ++i) {
      var cardView = this.display.cards_sm[Card.getId(cards[i].suit, cards[i].rank)];

      if (cardView.parent == this.display.upper_stage) {
        var filterBright = new PIXI.filters.ColorMatrixFilter();
        filterBright.brightness(0.3, true);
        cardView.filters=[filterBright];
      }
    }
    this.display.renderer_upper.render(this.display.upper_stage);
  }
};
KingView.prototype.addPointToTotalPointViews = function(points) {
  for (var seat in points) {
    var seatPos = parseInt(seat);
    var playerView = this.display.playerViews[seatPos];
    var totalPointView = playerView.usernameGroup.totalPoint;
    var currentPoint = parseInt(totalPointView.text);
    if (currentPoint) {currentPoint = currentPoint + points[seat];}
    else {currentPoint = points[seat];}
    var str = (currentPoint>0?'+':'');
    str += currentPoint;
    totalPointView.text = str;
    totalPointView.style.fill = (currentPoint>=0?this.textGreen:'red');
  }
}
KingView.prototype.addTakenTrick = function(seat, num) {
	var playerView = this.display.playerViews[seat];
  var numOfTricksView = playerView.usernameGroup.numOfTakenTricks;
  var cnt = parseInt(numOfTricksView.text);
  numOfTricksView.text = cnt+num;
};
KingView.prototype.endTrick = function(taker, endedTrick, cardsWPoint, isTrickWPoint) {
  var that=this;
  
  setTimeout(function() {
    if (cardsWPoint && cardsWPoint.length) {
      that.addTakenCardsWPoint(taker.seat, cardsWPoint);
      that.addTakenTrick(taker.seat, cardsWPoint.length);
    }

    if (isTrickWPoint) {that.addTakenTrick(taker.seat, 1);}

  }, that.trickEndTO);
};
KingView.prototype.endUnit = function(totalTrick) {
  var that=this;
};
KingView.prototype.init_unit = function() {
  var players = this.model.getPlayers();
  var that=this;
  
  if (!this.smallScreen) {
	  for (var i=0; i<players.length; ++i) {
		  var player = players[i];
		  var playerView = this.display.playerViews[player.seat];
		  playerView.hand.removeChildren();
	  }
  }
  else {
    while (this.display.upper_stage.children.length > 0) {
      var takenImg = this.display.upper_stage.children[0];
      takenImg.parent.removeChild(takenImg);
      takenImg.filters=undefined;
    }
      
    this.display.renderer_upper.render(this.display.upper_stage);
  }

  this.myHand.position.set(this.myHandX, this.myHandY);
  this.$chosenUnitFigDiv.fadeOut();
  this.$chosenUnitFigDiv.empty();
  
  that.clearHand();

  setTimeout(function() {
    if (!that.selectUnitMode && that.activeDialog != CardView.DIALOGS.SELECT_UNIT) {
      that.timeoutIDs[CardView.TIMEOUTIDS.WAIT_SELECT] = that.showDialog(CardView.DIALOGS.WAIT_SELECT, true);
    }
  }, 5000);
  
  for (var i=0; i<players.length; ++i) {
    var playerView = that.display.playerViews[players[i].seat];
    var nonTrumpCardsView = playerView.nonTrumpCardsView;
    if (nonTrumpCardsView) {nonTrumpCardsView.removeChildren();}
    var numOfTricksView = playerView.usernameGroup.numOfTakenTricks;
    if (numOfTricksView) {numOfTricksView.text='0';numOfTricksView.style.fill='red';}
  }
  for (var s in Card.SUITS) {
    for (var r in Card.RANKS) {
      that.display.cards[Card.getId(s, r)].reset();
      that.display.cards_cp[Card.getId(s, r)].reset();
    }
  }
};
KingView.prototype.addPoints = function(kingUnit, points) {
  var $total = $('#scoreTable').find('#TOTAL');
  var row = 0;
  var isTrump = kingUnit.indexOf('KOZ')==0;
  var $row = $('#scoreTable').find('#'+(isTrump?'KOZ':(kingUnit+'-0')));

  if (!isTrump && $($row.find('td')[1]).text()) {$row = $('#scoreTable').find('#'+kingUnit+'-1');row = 1;}
  for (var seat in points) {
    var seatPos = parseInt(seat);
    var $cell = $($row.find('td')[row==0?seatPos+1:seatPos]);
    if ($cell.text()) {$cell.text(parseInt($cell.text())+points[seat]);}
    else {$cell.text(points[seat]);}
    var $totalCell = $($total.find('td')[seatPos+1]);
    var currentPoint = parseInt($totalCell.text());
    if (currentPoint) {currentPoint = currentPoint + points[seat];}
    else {currentPoint = points[seat];}
    if (currentPoint < 0) {$totalCell.css('color', '#f00');}
    else {$totalCell.css('color', 'rgb(31, 255, 0)');}
    $totalCell.text(currentPoint);
  }
};
KingView.prototype.showChosenUnit = function(kingUnit) {
	this.hideDialog(CardView.DIALOGS.SELECT_UNIT,true);
  this.cancelShowDialog(CardView.TIMEOUTIDS.WAIT_SELECT, CardView.DIALOGS.WAIT_SELECT);
    var srcFig = "";
    var srcFont = "";
    var fontClass = "";
    if (kingUnit == 'ERKEK_ALMAZ') {srcFig="erkek_almaz-m.png";}
    else if (kingUnit == 'KIZ_ALMAZ') {srcFig="kiz_almaz-m.png";}
    else if (kingUnit == 'SON_IKI') {srcFig="son_iki-m.png";}
    else if (kingUnit == 'RIFKI') {srcFig="rifki-m.png";}
    else if (kingUnit == 'EL_ALMAZ') {srcFig="el_almaz-m.png";}
    else if (kingUnit == 'KUPA_ALMAZ') {srcFig="kupa_almaz-m.png";}
    else if (kingUnit == 'KOZ_MACA') {srcFig="spades160.png";}
    else if (kingUnit == 'KOZ_KARO') {srcFig="diamonds160.png";}
    else if (kingUnit == 'KOZ_SINEK') {srcFig="clubs160.png";}
    else if (kingUnit == 'KOZ_KUPA') {srcFig="hearts160.png";}
    
    var img = document.createElement('img');
    img.src = "king/assets/"+srcFig;
    this.$chosenUnitFigDiv.append(img);
    var that=this;
    img.onload = function() {
      that.$chosenUnitFigDiv.fadeIn();
    }
    
    for (var pos in this.playerPosCoords) {
      var seat = CardView.PLAYER_POSITIONS[pos].val;
      var playerView = this.display.playerViews[seat];
      var numOfTricksView = playerView.usernameGroup.numOfTakenTricks;
      if (!numOfTricksView) {continue;}
      if (this.model.isTrumpGame()) {numOfTricksView.style.fill = this.textGreen;}
      else {numOfTricksView.style.fill = 'red';}
    }
};
KingView.prototype.showWPoint = function(cardsWPoint, suitsWPoint, ranksWPoint) {
  var cards = [];
  
  if (cardsWPoint) {
    for (var i=0;i<cardsWPoint.length;++i) {
      cards.push(cardsWPoint[i]);
    }
  }
  if (suitsWPoint) {
    for (var i=0;i<suitsWPoint.length;++i) {
      for (var r in Card.RANKS) {
        cards.push({suit: suitsWPoint[i], rank: r});
      }
    }
  }
  if (ranksWPoint) {
    for (var i=0;i<ranksWPoint.length;++i) {
      for (var s in Card.SUITS) {
        cards.push({suit: s, rank: ranksWPoint[i]});
      }
    }
  }
  
  if (cards.length <= 0) {return;}
  
  cards = $.distinct(cards, function(a) {return Card.getId(a.suit, a.rank);});
  
  var xOffset=0, yOffset=0;
  var btwCardsX = this.cardwPointWsm;
  var btwCardsY = this.cardwPointHsm;
  var numLine = (cards.length*this.cardwPointWsm*0.9 <= this.upperStageW)?1:2;
  yOffset = Math.floor((this.upperStageH - numLine*this.cardwPointHsm)/2);
  if (numLine == 2) {
    if (numLine*this.cardwPointHsm*0.8 < this.upperStageH) {
      if ((this.upperStageH - numLine*this.cardwPointHsm) < 0) {
        var excessOnEach = (numLine*this.cardwPointHsm - this.upperStageH)/(numLine-1);
        btwCardsY -= Math.floor(excessOnEach);
        yOffset = -1*Math.floor(excessOnEach/2);
      }
    }
    else {
      numLine = 1;
    }
  }

  var numOfInOneLine = Math.round(cards.length/numLine);
  if (numOfInOneLine*this.cardwPointWsm > this.upperStageW) {
    btwCardsX -= Math.floor((numOfInOneLine*this.cardwPointWsm - this.upperStageW)/(cards.length-1));
  }
  
  var useW = (numOfInOneLine-1)*btwCardsX + this.cardwPointWsm;
  if (useW < this.upperStageW) {
    xOffset = Math.floor((this.upperStageW - useW)/2);
  }

  for (var i=0; i<cards.length; ++i) {
    var img = this.display.cards_sm[Card.getId(cards[i].suit, cards[i].rank)];
    var row = Math.floor(i/numOfInOneLine);
    var column = (i%numOfInOneLine);
    img.position.set(xOffset + column*btwCardsX, row*btwCardsY+(row==0?yOffset:0));
    this.display.upper_stage.addChild(img);
  }

  this.display.renderer_upper.render(this.display.upper_stage);
};
KingView.prototype.showNextTrickPlayer = function(seat) {
    var playerView = this.display.playerViews[seat];
    var usernameView, coords;
    if (!this.smallScreen) {
      usernameView = playerView.usernameGroup.bg;
    }
    else {
      usernameView = playerView;//.yourTurnArrow;
      coords = this.playerPosCoords[playerView.pos];
    }
    
    //usernameView.setAttr('isBlinking', true);
    this.blinkUsername(usernameView, true, coords);
    
    /*if (this.model.getMe() && this.model.getMe().seat == seat) {
      if (this.soundEnabled && getHidden()) {this.domExt['aud-yourTurn'][0].play();}
    }*/
}
KingView.prototype.blinkUsername = function(usernameView, first, coords) {
  var that=this;
  var thisView = usernameView;
  if (!this.smallScreen) {
  }
  else {
    usernameView.yourTurnArrow.visible = true;
    usernameView.yourTurnArrowTween.play();
    return;
  }
}
KingView.prototype.unblinkUsername = function(player) {
    var playerView = this.display.playerViews[player.seat];
    var usernameView;
    if (!this.smallScreen) {
      usernameView = playerView.usernameGroup.bg;
    }
    else {
      playerView.yourTurnArrow.visible = false;
      playerView.yourTurnArrowTween.pause();
    }
    
    //usernameView.isBlinking = false;
}


KingView.prototype.showSelectUnit = function(units) {
	var that=this;
	
	that.cezaUnits = [];
	that.kozUnits = [];
	for (var i=0;i<units.length;++i) {
		switch (units[i]) {
			case 'ERKEK_ALMAZ':
				that.cezaUnits.push({unit:'ERKEK ALMAZ', unitN:units[i], src:'erkek_almaz.png'});
			break;
			case 'KIZ_ALMAZ':
				that.cezaUnits.push({unit:'KIZ ALMAZ', unitN:units[i], src:'kiz_almaz.png'});
			break;
			case 'SON_IKI':
				that.cezaUnits.push({unit:'SON İKİ', unitN:units[i], src:'son_iki.png'});
			break;
			case 'RIFKI':
				that.cezaUnits.push({unit:'RIFKI', unitN:units[i], src:'rifki.png'});
			break;
			case 'EL_ALMAZ':
				that.cezaUnits.push({unit:'EL ALMAZ', unitN:units[i], src:'el_almaz.png'});
			break;
			case 'KUPA_ALMAZ':
				that.cezaUnits.push({unit:'KUPA ALMAZ', unitN:units[i], src:'kupa_almaz.png'});
			break;
			case 'KOZ_MACA':
				that.kozUnits.push({unit:'KOZ MAÇA', unitN:units[i], src:'spades90.png'});
			break;
			case 'KOZ_KARO':
				that.kozUnits.push({unit:'KOZ KARO', unitN:units[i], src:'diamonds90.png'});
			break;
			case 'KOZ_SINEK':
				that.kozUnits.push({unit:'KOZ SİNEK', unitN:units[i], src:'clubs90.png'});
			break;
			case 'KOZ_KUPA':
				that.kozUnits.push({unit:'KOZ KUPA', unitN:units[i], src:'hearts90.png'});
			break;
		}
	}
	
	that.selectUnitMode = true;
	that.cancelShowDialog(CardView.TIMEOUTIDS.WAIT_SELECT, CardView.DIALOGS.WAIT_SELECT);
	that.activeDialog = CardView.DIALOGS.SELECT_UNIT;
}



//@ sourceURL=king.js
