(function () {
	var kingApp = angular.module('KingApp', ['RoomModule', 'wsClientModule', 'UserAuthModule', 'ngRoute', 'ngAnimate', 'ngTouch'])
	.config(['$routeProvider', '$locationProvider', function($routeProvider, $locationProvider) {
		$routeProvider
			.when('/king/masa/:roomId', {
				templateUrl: 'king/html/temp/masa.html',
				controller: 'GameController',
				controllerAs: 'GameCtrl',
				resolve: {
					 ready: ['roomJoinService', '$route', function(roomJoinService, $route) {
					   roomJoinService.init();
						 if (!roomJoinService.isInRoom().$$state.status) { 
							 roomJoinService.joinRoom($route.current.params.roomId);
					   }
						 
						 return roomJoinService.isInRoom();
					 }]
				}
			})
			/*.when('/rooms', {
				templateUrl: 'static/html/temp/rooms-temp.html',
				controller: 'RoomController',
				controllerAs: 'RoomCtrl'
			})*/
			.otherwise({
				templateUrl: 'king/html/temp/rooms-temp.html',
				controller: 'RoomController',
				controllerAs: 'RoomCtrl'
			});
			/*.when('/#/rooms', {
				templateUrl: 'static/html/temp/rooms-temp.html',
				controller: 'RoomController',
				controllerAs: 'RoomCtrl'
			});*/

		if (html5Mode) {$locationProvider.html5Mode(html5Mode).hashPrefix('!');}
	}
	
	]);
	
	kingApp.filter('unsafeHtml', ['$sce', function($sce) {
	  return function(val) {
	    return $sce.trustAsHtml(val);
	  };
	}]);
	
	kingApp.run(['$rootScope', function($rootScope) { // adding isEmpty function
		$rootScope.isEmpty = function(obj) {
			return !obj || Object.keys(obj).length == 0;
		}
	}])
	
	kingApp.value('assetDir', 'assets/');
	kingApp.service("ScreenSizeService", [function() {
		this.getMaxScreenSize = function() {
			var screenRealW = screen.width/devicePixelRatio;
			if (screenRealW<768) {return 'xs';}
			if (screenRealW>767 && screenRealW<992) {return 'sm';}
			if (screenRealW>991 && screenRealW<1200) {return 'md';}
			if (screenRealW>1199) {return 'lg';}
		}
		this.maxScreenSize = this.getMaxScreenSize();
		this.isSmallScreen = function() {
			return this.maxScreenSize == 'xs' || this == 'sm';
			//return true;
		}
	}]);
	
	kingApp.controller("MainController", ['$scope', '$location', 'roomJoinService', function($scope, $location, roomJoinService) {
		console.log('MAIN CONTROLLER');
		this.roomJoinService = roomJoinService;
		$scope.$on('$routeChangeError', function($routeChangeError) {
			console.error($routeChangeError);
			console.error($location);
			$location.path('/king/rooms');
		});
	}]);

	
	kingApp.service("GameView", ['$q', 'ScreenSizeService', 'GameModel', function($q, ScreenSizeService, GameModel) {
		this.view = new KingView();
		var view=this.view;
		view.cv = CardView;
		
		view.screenSizeService = ScreenSizeService;
		this.view.model = GameModel.model;
		this.view.display={};
		
		if (ScreenSizeService.isSmallScreen()) {
		  view.smallScreen = true;
		  view.customize('sm');
		}
		else {
		  view.smallScreen = false;
		  view.customize('lg');
		}
	}]);
	
	
	kingApp.service("GameModel", [function() {
		this.model = new KingModel();
	}]);
	
	kingApp.controller("GameController", ['$q', 'wsService', '$scope', 'assetManager', 'GameView', 'GameModel', 'MyData', 'roomJoinService', 'setUserDataService', function($q, wsService, $scope, assetManager, GameView, GameModel, MyData, roomJoinService, setUserDataService) {
/*alert('w:'+screen.width+'; h:'+screen.height);
alert('w:'+screen.availWidth+'; h:'+screen.availHeight);
alert('w:'+window.innerWidth+'; h:'+window.innerHeight);
alert('O: '+window.orientation);
*/
	  
console.log("---------------------- GAMECONTROLLER --------------------------");

this.addAutoPlayers = function() {
  var seats = {};
  for (var key in CardView.PLAYER_POSITIONS) {seats[CardView.PLAYER_POSITIONS[key].val]=CardView.PLAYER_POSITIONS[key].val;}
  var players = this.model.getPlayers();
  for (var key in players) {
    if (seats[players[key].seat]) {delete seats[players[key].seat];}
  }
  
  for (var key in seats) {
    this.onClickedSitDown(seats[key], "true");
  }
}

		var that=this;

		GameView.view.controller=this;

		this.view = GameView.view;
		this.model = GameModel.model;
		CardGame.view = GameView.view;
		
		this.setUserDataService = setUserDataService;
//    setUserDataService.enterUsername();
    setUserDataService.isSet().then(function() {
        that.model.setMyInfo(MyData.sessionId, setUserDataService.userData.username);
    });

    document.addEventListener("visibilitychange", function() {
      /*if (!document.hidden) {
        if (that.view.main_stage) {that.view.main_stage.draw();}
      }*/
    });

    $scope.$on('$destroy', function() {
      var uns;
      while (uns = that.unsubs.pop()) {
        uns.unsubscribe();
      }
      roomJoinService.exitRoom(roomJoinService.roomId);
    });

    CardGame.prototype.STATUS['UNIT_ENDED']='UNIT_ENDED';

    PIXI.loader.add('bcard', 'common/assets/bcard.png')
    		   .add('chair', 'common/assets/chair.png')
    		   .add('nameplate', 'common/assets/nameplate.png')
    		   .add('nameplate_sm', 'common/assets/nameScorePlate.png')
    		   .add('yourTurnArrow', 'common/assets/arrow-sm-green.png')
    		   .add('cards', 'common/assets/cards.png')
    		   .add('takensm', 'king/assets/taken_sm.png')
    		   .load(function(loader, resources) {
    			   that.view.display.bcard = new PIXI.Sprite(resources.bcard.texture);
    			   that.view.display.nameplate = new PIXI.Sprite(resources.nameplate.texture);
    			   that.view.display.nameplate_sm = new PIXI.Sprite(resources.nameplate_sm.texture);
    			   that.view.display.yourTurnArrow = new PIXI.Sprite(resources.yourTurnArrow.texture);
    			   that.view.display.cards={};
    			   that.view.display.cards_sm={};
    			   that.view.display.cards_cp={};
    			   var cards = resources.cards.texture;
    			   var coords = assetManager.repartImgs(cards, that.view.cardW, that.view.cardH);
    			   var i=0,j=0;
				   for (var s in Card.SUITS) {
				       for (var r in Card.RANKS) {
				         var texture = new PIXI.Texture(cards, new PIXI.Rectangle(coords[i*Card.NumOfRanks+j].x,coords[i*Card.NumOfRanks+j].y,that.view.cardW,that.view.cardH));
				    	   that.view.display.cards[Card.getId(s,r)] 
				    		   = new Card(texture, s, r);
				    	   that.view.display.cards_cp[Card.getId(s,r)]
				    	     = new Card(texture, s, r);
							++j;
						}
						++i;j=0;
				   }
				   
				   var takensm = resources.takensm.texture;
				   var coords2 = assetManager.repartImgs(takensm, that.view.cardwPointWsm, that.view.cardwPointHsm);
				   var i=0,j=0;
					for (var s in Card.SUITS) {
						for (var r in Card.RANKS) {
							that.view.display.cards_sm[Card.getId(s,r)]
								= new PIXI.Sprite(new PIXI.Texture(takensm, new PIXI.Rectangle(coords2[i*Card.NumOfRanks+j].x,coords2[i*Card.NumOfRanks+j].y,that.view.cardwPointWsm,that.view.cardwPointHsm)));
							++j;
						}
						++i;j=0;
					}

			    	that.init();
    		   });		      
		
		this.unsubs=[];

		this.init = function() {
		  this.model.reset();
		  this.model.init();
		  this.view.init();

console.log('VIEW INIT BITTI...');

      	that.gameStatus = CardGame.prototype.STATUS.NOT_READY;
      	that.gameStatusVer = -1;
      	that.gameStatusQueue = [];
      	that.model.setMyInfo(MyData.sessionId, MyData.sessionId);
   
      	roomJoinService.subscribeMeToRoom(roomJoinService.roomId, that.msgHandler);
      	roomJoinService.getRoomInfo(roomJoinService.roomId);
      	roomJoinService.gotRoomInfo().then(function() {
      		that.joinedInRoom(MyData.room.extInfo);

      		that.unsubs.push(wsService.subscribe('/topic/game/'+MyData.room.id+'/**', {}, that.msgHandler));
      		that.unsubs.push(wsService.subscribe('/user/queue/game/'+MyData.room.id, {}, that.msgHandler));
      	});  	
      	setUserDataService.enterUsername();
	  }
		
		this.joinedInRoom = function(gameProps) {
			if (!gameProps) {return;}
			this.gameStatus = gameProps.gameStatus;
			this.gameStatusVer = gameProps.statusVer;
			var seats = gameProps.seats;
			for (var i=0;i<seats.length;++i) {
			  if (seats[i].occupied) {
			    this.addPlayer(seats[i].userid, seats[i].username, seats[i].position);
			  }
			}
			  
			if (this.gameStatus == CardGame.prototype.STATUS.STOPPED) {
			  this.model.setCurrentDealNum(gameProps.totalPlayedUnit);
			  this.view.initToResume(gameProps);
			}
		}
		
		this.addPlayer = function(userid, username, pos) {
console.log('ADDING PLAYER...'+userid+' '+username+' '+pos);
			var player = new CardPlayer(userid, username, pos);
			if (!this.model.addPlayer(player)) {return;}
			var isMe = this.model.isMe(player);
			this.view.addPlayer(player, isMe);
		}
		this.removePlayer = function(userid) {
			var pl = this.model.removePlayer(userid);
			if (pl) {this.view.removePlayer(pl);}
		}
		this.gameStatusChanged = function(gameStatus, statusVer, data) {
			
			if (!CardGame.prototype.STATUS[gameStatus]) {return;}
			
			var newStatus = gameStatus;
			var newVer = statusVer;
			if (this.gameStatusVer == -1) {
			    this.updateGameStatus(newStatus, newVer, data);
			}
			else if (this.gameStatusVer+1 == newVer) {
			    this.updateGameStatus(newStatus, newVer, data);
			    for (var i=0;i<this.gameStatusQueue.length;++i) {
			      var newFromQ = this.gameStatusQueue[i];
			      if (this.gameStatusVer+1 == newFromQ.ver) {
			        this.updateGameStatus(newFromQ.st, newFromQ.ver, newFromQ.data);
			        this.gameStatusQueue.splice(i,1);
			        --i;
			      }
			      else {break;}
			    }
			}
			else if (this.gameStatusVer < newVer) {
				console.error('?????????????????????????????????????????????????????');
			    this.gameStatusQueue.push({st:newStatus, ver:newVer, data:data});
			    this.gameStatusQueue.sort(function(a,b){return a.ver > b.ver;});
			}
		}
		
		this.updateGameStatus = function(newStatus, newVer, data) {
			var oldGameStatus = this.gameStatus;
			
			this.gameStatus = newStatus;
			this.gameStatusVer = newVer;
			var that=this;
			  
			switch (newStatus) {
			    case CardGame.prototype.STATUS.NOT_READY:
			      this.view.notReadyToStart();
			    break;
			    case CardGame.prototype.STATUS.READY_TO_START:
			      setTimeout(function() {that.onClickedStartGame()}, 5000);
			      this.view.getReadyToStart();
			    break;
			    case CardGame.prototype.STATUS.STARTED:
			      this.model.startGame();
			      this.view.startGame();
			    break;
			    case CardGame.prototype.STATUS.ENDED:
			      this.model.endGame();
			      this.view.endGame();
			    break;
			    ///////////////////////////////////////////////////////
			    case CardGame.prototype.STATUS.UNIT_ENDED:
			        console.log('MESSAGE END UNITTTTTTTTTTTT');
			        this.model.endUnit(data.totalPlayedUnit);
			        this.view.endUnit(data.totalTrick);

			        if (!data.isFinalUnit) {
			          var that = this;
			          setTimeout(function() {
			            that.init_unit();
			            that.readyToNewUnit();
			          }, this.view.unitEndTO);
			        }
			    break;
			    case CardGame.prototype.STATUS.PLAYING:
			        if (oldGameStatus == CardGame.prototype.STATUS.STOPPED) {
			          this.view.resumeGame();
			        }
			    break;
			    default:break;
			}
			  
			console.log('GAME STATUS CHANGED !!!!');
		}
		
		this.startRequest = function(userid) {
		  this.view.pushToQueue(this.view.startRequest, [this.view, userid]);
			//this.view.startRequest(userid);
		}
		
		this.setStarter = function(userid) {
			var player = this.model.getPlayer(userid);
			if (!player) {return;}
			this.model.setNextPlayerPos(player.seat);
			this.view.setNextPlayer(player);
		}
		
		this.dealMyHand = function(hand) {
			hand.forEach(function(c){Card.addVal(c);});
			this.model.setHand(hand);
			this.view.pushToQueue(this.view.dealHand, [this.view]);
			//this.view.dealHand();
		}
		
		this.playCardOnTable = function(userid, cardobj, dealNum, trick) {
			var player = this.model.getPlayer(userid);
			if (!player) {return;}
			var card = Card.addVal(cardobj);
			this.model.playCardOnTable(card, player);
			this.view.pushToQueue(this.view.playCardOnTable, [this.view,card,player,dealNum,trick], true);
			//this.view.playCardOnTable(card, player, dealNum, trick);
		}
		
		//////////////////////////////////////////////////////////////////////
		
		this.nextTrickPlayer = function(userid) {
			var player = this.model.getPlayer(userid);
		    this.model.setNextTrickPlayerPos(player.seat);

		    var that=this;
		    this.view.pushToQueue(this.view.showNextTrickPlayer, [this.view, player.seat]);
		    //this.view.showNextTrickPlayer(player.seat);
		}
		
		this.chooseUnitOptions = function(kingUnits) {
		  var that=this;
		  this.view.pushToQueue(this.view.showSelectUnit, [this.view, kingUnits], false, that.endAsyncCallback);
		  //this.view.showSelectUnit(kingUnits, this.endAsyncCallback);
		}
		
		this.unitChosen = function(kingUnit, isTrumpGame, cardsWPoint, suitsWPoint, ranksWPoint) {
			this.view.selectUnitMode = false;
			this.view.kozUnits=[];
			this.view.cezaUnits=[];
			this.varUnitChosen=undefined;
			this.model.setCurrentUnit({unit: kingUnit, isTrump: isTrumpGame});
			
			this.view.pushToQueue(this.view.showChosenUnit, [this.view,kingUnit]);
			//this.view.showChosenUnit(kingUnit);
			if (this.view.smallScreen && (cardsWPoint || suitsWPoint || ranksWPoint)) {
			  this.view.pushToQueue(this.view.showWPoint, [this.view, cardsWPoint, suitsWPoint, ranksWPoint]);
			  //this.view.showWPoint(cardsWPoint, suitsWPoint, ranksWPoint);
			}
			this.view.pushToQueue(this.endAsyncCallback, [this]);
			//$scope.$apply();
		}
		
		this.endTrick = function(trickTaker, cardsWPoint, currentDealNum, endedTrick, isTrickWPoint) {
			var player = this.model.getPlayer(trickTaker);
			if (!player) {return;}
			this.model.endTrick(currentDealNum, player);
			if (cardsWPoint) {
			  for (var i=0;i<cardsWPoint.length;++i) {
				  Card.addVal(cardsWPoint[i]);
			  }
			}
			this.view.pushToQueue(this.view.endTrick, [this.view, player, endedTrick, cardsWPoint, isTrickWPoint]);
			//this.view.endTrick(player, endedTrick, cardsWPoint, isTrickWPoint);
		}
		
		this.playableCards = function(plCards) {
			plCards.forEach(function(c){Card.addVal(c);});
			this.view.pushToQueue(this.view.enableHand, [this.view, plCards]);
			//this.view.enableHand(plCards);
		}
		
		this.addPoints = function(kingUnit, points) {
			this.view.addPoints(kingUnit, points);
			if (this.view.smallScreen) {
			  this.view.pushToQueue(this.view.addPointToTotalPointViews, [this.view, points]);
				//this.view.addPointToTotalPointViews(points);
			}
		}
		
		this.endAsyncCallback = function() {
			$scope.$apply();
		}

		var that=this;
		this.msgHandler = function(resp) {
			var msg = JSON.parse(resp.body);
console.log('RESP: '+msg.type);
			switch (msg.type) {
				case 'SIT_DOWN':
					that.addPlayer(msg.userid, msg.username, msg.seat);
//$scope.$apply();
				break;
				
				case 'GET_UP':
					that.removePlayer(msg.userid);
				break;
				
				case 'GAME_START_REQUEST':
					that.startRequest(msg.userid);
				break;
				
				case 'PLAY_CARD_ON_TABLE':
					that.playCardOnTable(msg.userid, msg.card, msg.dealNum, msg.trick);
				break;
				
				case 'EXIT_ROOM':
					that.removePlayer(msg.userid);
				break;
				
				case 'GAME_STATUS_CHANGED':
				  that.view.pushToQueue(that.gameStatusChanged, [that, msg.gameStatus, msg.statusVer, msg.data]);
					//that.gameStatusChanged(msg.gameStatus, msg.statusVer, msg.data);
				break;
				
				case 'DEAL_HAND':
					that.dealMyHand(msg.hand);
				break;
				
				case 'STARTER':
					that.setStarter(msg.userid);
				break;
				
				////////////////////////////////////////////////////////////////			
				
				
				case 'NEXT_TRICK_PLAYER':
					that.nextTrickPlayer(msg.userid);
				break;
				
				case 'CHOOSE_UNIT_OPTIONS':
					that.chooseUnitOptions(msg.kingUnits);
				break;
				
				case 'UNIT_CHOSEN':
					that.unitChosen(msg.kingUnit, msg.isTrumpGame, msg.cardsWPoint, msg.suitsWPoint, msg.ranksWPoint);
				break;
				
				case 'PLAYABLE_CARDS':
					that.playableCards(msg.cards);
				break;
				
				case 'END_TRICK':
					that.endTrick(msg.trickTaker, msg.cardsWPoint, msg.currentDealNum, msg.endedTrick, msg.isTrickWPoint);
				break;
				
				case 'ADD_POINTS':
					that.addPoints(msg.kingUnit, msg.points);
				break;

			}

			$scope.$apply();
		}
		
		this.readyToNewUnit = function() {
			wsService.send('/king/game/'+MyData.room.id+'/unitEnded', {}, {});
		}
		this.init_unit = function() {
			this.model.init_unit();
			this.view.pushToQueue(this.view.init_unit, [this.view]);
			//this.view.init_unit();
		}
		
		this.onClickedSitDown = function(pos, isAuto) {
		  if (!isAuto) {isAuto = false;}
			wsService.send('/king/room/'+MyData.room.id+'/sitdown/'+pos, {}, {username: that.model.getMyInfo().username, isAuto: isAuto});
		};
		
		this.onClickedStartGame = function() {
			wsService.send('/king/game/'+MyData.room.id+'/gameStartRequest', {}, {});
		};
		this.onClickedHandCard = function(id) {
			wsService.send('/king/game/'+MyData.room.id+'/playCardOnTable', {}, {card:id});
		};
		this.onClickUnitChosen=function(kingUnit){
			wsService.send('/king/game/'+MyData.room.id+'/unitChosen/'+kingUnit);
		}

	}]);
	
	
	
	kingApp.service("assetManager", ['$q', 'assetDir', function($q, assetDir) {
		this.assets = {};
		var listener = $q.defer();
		this.allLoaded = function() {return listener.promise};
		this.addAsset = function(key, asset) {
			this.assets[key] = asset;
		}
		this.repartImgs = function(img, w, h) {
			  var imgs = [];
			  var imgW = img.naturalWidth || img.width;
			  var imgH = img.naturalHeight || img.height;

			  var totalImgs = imgW/w * imgH/h;

			  for (var y=0; y<(imgH/h); ++y) {
			  	for (var x=0; x<(imgW/w); ++x) {
			  		imgs.push({x:x*w,y:y*h});
			  	}
			  }
			  return imgs;
		}
	}]);
	
})();


