(function() {
	var roomModule = angular.module('RoomModule', ['wsClientModule']);
	
	roomModule.service("roomJoinService", ['$q', 'wsService', 'MyData', function($q, wsService, MyData) {
		console.log('^^^^^^^^^^^^^^^^ roomJoinService ^^^^^^^^^^^^^^^^^^');
				var that=this;
				this.inited = false;
				
				//var listener = $q.defer();
				var isInRoom = $q.defer();
				var isReady = $q.defer();
				var gotRoomInfo = $q.defer();
				
				this.roomId;
				this.isInRoom = function() {
					return isInRoom.promise;
				}
				
				this.gotRoomInfo = function() {
				  return gotRoomInfo.promise;
				}
				
				/*this.respHandler = function() {
					return listener.promise;
				}*/
				var defaultCallback = function(resp) {
					//listener.notify(JSON.parse(resp.body));
				}
				
				this.unsubs = [];
				
				this.init = function() {
				  if (this.inited) {return;}
				  this.inited = true;
				  wsService.isConnected().then(function() {
					  MyData.room = null;
					  that.unsubs.push(wsService.subscribe('/user/queue/room', {}, defaultCallback));
					  isReady.resolve();
				  });
				}
				this.clean = function() {
				  this.inited = false;
				  var uns;
          while (uns = this.unsubs.pop()) {
            uns.unsubscribe();
          }
          MyData.room = null;
          isInRoom = $q.defer();
          isReady = $q.defer();
          gotRoomInfo = $q.defer();
          this.roomId = null;
				}
				
				this.init();
				
				this.joinRoom = function(roomId, psw, isPrivate, fromModalEvent) {
					if (MyData.room) {console.warn('Already in a room!');}
					if (isInRoom.promise.$$state.status) {isInRoom = $q.defer();}

					if (fromModalEvent && $(event.target)[0].dataset.roomid) {roomId = $(event.target)[0].dataset.roomid;}
					if (!roomId) {console.error('roomid undefined');}

					if (isPrivate == 'true' && !psw) {
						this.getPassword(roomId);
						return;
					}
					
					var that=this;
					isReady.promise.then(function() {
						var header = (psw?{psw:psw}:{});
						wsService.subscribe('/king/joinRoom/'+roomId, header, function(resp) {
							if (resp.body == "OK") {
							  isInRoom.resolve();
							  that.roomId = roomId;
							}
							else if (resp.body == "NEEDPSW"){
								that.getPassword(roomId);
							}
							else {
								console.error('Cant join on this room');
								isInRoom.reject();
							}
						});
					});
				}
				var unsubs = [];
				this.subscribeMeToRoom = function(roomId, callback) {
				  this.unsubs.push(wsService.subscribe('/topic/room/'+roomId+'/**', {}, callback?callback:defaultCallback));
				}
				this.getRoomInfo = function(roomId) {
					wsService.subscribe('/king/roomInfo/'+roomId, {}, function(resp) {
						var msg = JSON.parse(resp.body);
						MyData.room = msg.room;
						
						if (msg.extRoomInfo) {MyData.room.extInfo = msg.extRoomInfo;}
						gotRoomInfo.resolve();
					});
				}
				this.createRoom = function(data) {
					wsService.send('/king/createRoom', {}, data);
				}
				
				this.getPassword = function(roomId) {
					var modal$ = $('#modalEnter2Room');
					modal$.find('#butEnter2Room')[0].dataset.roomid=roomId;
					modal$.modal();
				}
				
				this.exitRoom = function(roomId) {
				  this.clean();
				  wsService.send('/king/exitRoom');
				}				

	}]);
	
	roomModule.controller("RoomController", ['$route', '$routeParams', '$location', '$scope', 'wsService', 'MyData', 'roomJoinService', function($route, $routeParams, $location, $scope, wsService, MyData, roomJoinService) {
console.log('ROOMCONTROLLER ............ INITIALIZINGGGGGGGGGGGGGGGGGGGGGGGGGGGGGG');
		var that=this;
		this.$route = $route;
		this.$location = $location;
		this.$routeParams = $routeParams;
		this.rooms;
		
		this.roomJoinService = roomJoinService;
		this.unsubs = [];
		
		$scope.$on('$destroy', function() {
		  var uns;
		  while (uns = that.unsubs.pop()) {
		    uns.unsubscribe();
		  }
		});
		
		var msgHandler = function(resp) {
      var msg = JSON.parse(resp.body);
      console.log("RESP GELDI: " + msg.type);
      console.log(resp);

      switch (msg.type) {
        case 'GET_ROOMS':
          MyData.sessionId = msg.sessionId;
          if (msg.rooms) {that.rooms = msg.rooms;}
          $scope.$apply();
          break;
        case 'ROOM_CREATED':
          if (!that.rooms) {that.rooms={};}
          that.rooms[msg.room.id] = msg.room;
        
          if (msg.room.Creator === MyData.sessionId) {
console.log('BENIM ODAM');
            $location.path('/king/masa/'+msg.room.id);
          }
          $scope.$apply();
          break;
      }
    }
		
		wsService.isConnected().then(function() {
		  var uns = wsService.subscribe('/topic/rooms/**', {}, msgHandler);
		  that.unsubs.push(uns);
		});


		this.getRooms = function() {
console.log('GET ROOMS');
			wsService.isConnected().then(function(){wsService.subscribe('/king/getRooms', {}, msgHandler)});
		};
		
		this.createRoom = function(data) {
			roomJoinService.createRoom(data, function(resp) {
console.log(resp);
			});
		};
		
		this.joinRoom = function(roomid, psw, isPrivate) {
			roomJoinService.joinRoom(roomid, psw, isPrivate);
			roomJoinService.isInRoom().then(function() {$location.path('/king/masa/'+roomid);});
		};
		
		this.getRooms();
		
	}]);
	
	
})();